---
title: 'ARIA: listbox role'
slug: Web/Accessibility/ARIA/Roles/listbox_role
tags:
  - ARIA
  - Accessibility
  - NeedsContent
---
<p>{{Page("/en-US/docs/Web/Accessibility/ARIA/Roles", "Subnav")}}</p>

<ul class="ul1">
</ul>

<ul class="ul1">
</ul>

<p><span class="seoSummary">The <code>listbox</code> role is used for lists from which a user may select one or more items which are static and, unlike HTML &lt;select&gt; elements, may contain images.</span></p>

<h2 id="Description">Description</h2>

<p>The <code>listbox</code> role is used to identify an element that creates a list from which a user may select one or more static items, similar to the HTML &lt;select&gt; element. Unlike &lt;select&gt;, a listbox can contain images. Each child of a listbox should have a role of <a class="external" href="http://www.w3.org/TR/2010/WD-wai-aria-20100916/roles#option">option</a>.</p>

<p>It is highly recommended to use the HTML select element, or a group of radio buttons if only one item can be selected, or a group of checkboxes if multiple items can be selected, because there is a lot of keyboard interactivity to manage focus for all the descendants, and native HTML elements provide this functionality for you for free.</p>

<p>Elements with the role <code>listbox</code> have an implicit <code>aria-orientation</code> value of <code>vertical</code>.</p>

<p class="p1">When a list is tabbed to, the first item in the list will be selected if nothing else already is. Up/down arrows navigate the list, and pressing Shift + Up/Down arrows will move and extend the selection. Typing one or more letters will navigate the list items (same letter goes to each item starting with that, different letters go to the first item starting with that entire string). If the current item has an associated context menu, Shift+F10 will launch that menu. If list items are checkable, Space can be used to toggle <a class="external" href="http://www.w3.org/TR/wai-aria-practices/#checkbox">checkboxes</a>. For selectable list items, Space toggles their selection, Shift+Space can be used to select contiguous items, Ctrl+Arrow moves without selecting, and Ctrl+Space can be used to select non-contiguous items. It is recommended that a checkbox, link or other method be used to select all items, and Ctrl+A could be used as a shortcut key for this.</p>

<p class="li2">When the listbox role is added to an element, or such an element becomes visible, screen readers  announce the label and role of the listbox when it gets focus. If an option or item is focused within the list, it gets announced next, followed by an indication of the item's position with the list if the screen reader supports this. As focus moves within the list, the screen reader announces the relevant items.</p>

<h3 id="Associated_ARIA_roles_states_and_properties">Associated ARIA roles, states, and properties</h3>

<h4 id="Associated_Roles">Associated Roles</h4>

<dl>
	<dt><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Option_Role">option</a></dt>
	<dd>One or more nested options are required. All selected options have <code>aria-selected</code> set to <code>true</code>. All options that are not selected have <code>aria-selected</code> set to <code>false</code>.  If an option is not selectable, omit the <code>aria-selected</code>.</dd>
	<dt><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/List_role">list</a></dt>
	<dd>A section containing <code>listitem</code> elements</dd>
</dl>

<h4 id="States_and_Properties">States and Properties</h4>

<dl>
	<dt>aria-activedescendant</dt>
	<dd>Holds the <code>id</code> string of the currently active element within the listbox.  If that's an option element, then that would be the <code>id</code> of the most recently interacted with option, regardless of whether that option has an <code>aria-selected</code> value of <code>true</code> or not. Takes the value of only one <code>id</code>, even in a multiselectable listbox.  If the <code>id</code> does not refer to a DOM descendant of the listbox, then that <code>id</code> must be included among the IDs in the <code>aria-owns</code> attrubute.</dd>
	<dt>aria-owns</dt>
	<dd>This is a space-separated list of element IDs which are not DOM child elements of the listbox.  IDs listed here cannot also be listed in <code>aria-owns</code> attributes of any other elements.</dd>
	<dt>aria-multiselectable</dt>
	<dd>Include and set to <code>true</code> if the user can select more than one option. If set to <code>true</code>, <em>every</em> selectable option should have an <code>aria-selected</code> attribute included and set to <code>true</code> or <code>false</code>.  Options which are <em>not</em> selectable <em>should not</em> have the <code>aria-selected</code> attribute.</dd>
	<dd>If <code>false</code> or omitted, only the currently selected option, if any option is selected, needs the <code>aria-selected</code> attribute, and it must be set to <code>true</code>.</dd>
	<dt>aria-required</dt>
	<dd>A Boolean attribute which indicates that an option with a non-empty string value must be selected.</dd>
	<dt>aria-readonly</dt>
	<dd>The user cannot change which options are selected or unselected, but the listbox is otherwise operable.</dd>
	<dt>aria-label</dt>
	<dd>A human-readable string value which identifies the listbox.  If there's a visible label, then <code>aria-labelledby</code> should be used instead to refer to that label.</dd>
	<dt>aria-labelledby</dt>
	<dd>Identifies the visible element or elements in a space-separated list of element IDs which identify the listbox.  If there's no visible label, then <code>aria-label</code> should be used instead to include a label.  (Note: "labelled", with two L's, is the correct spelling based on the accessibility API conventions.)</dd>
	<dt>aria-roledescription</dt>
	<dd>A human-readable string value which more clearly identifies the role of the listbox.  Screen readers will often read this value to the user after reading the label (if there is one), in place of saying "listbox".</dd>
</dl>

<p>(For further details and a full list of ARIA states and properties see the <a href="https://www.w3.org/TR/wai-aria-1.1/#listbox">ARIA <code>listbox</code> (role)</a> documentation.)</p>

<h3 id="Keyboard_interactions">Keyboard interactions</h3>

<ul>
	<li>When a single-select listbox receives focus:
	<ul>
		<li>If none of the options are selected before the listbox receives focus, the first option receives focus. Optionally, the first option may be automatically selected.</li>
		<li>If an option is selected before the listbox receives focus, focus is set on the selected option.</li>
	</ul>
	</li>
	<li>When a multi-select listbox receives focus:
	<ul>
		<li>If none of the options are selected before the listbox receives focus, focus is set on the first option and there is no automatic change in the selection state.</li>
		<li>If one or more options are selected before the listbox receives focus, focus is set on the first option in the list that is selected.</li>
	</ul>
	</li>
	<li><kbd>Down Arrow</kbd>: Moves focus to the next option. Optionally, in a single-select listbox, selection may also move with focus.</li>
	<li><kbd>Up Arrow</kbd>: Moves focus to the previous option. Optionally, in a single-select listbox, selection may also move with focus.</li>
	<li><kbd>Home</kbd> (Optional): Moves focus to first option. Optionally, in a single-select listbox, selection may also move with focus. Supporting this key is strongly recommended for lists with more than five options.</li>
	<li><kbd>End</kbd> (Optional): Moves focus to last option. Optionally, in a single-select listbox, selection may also move with focus. Supporting this key is strongly recommended for lists with more than five options.</li>
	<li>Type-ahead is recommended for all listboxes, especially those with more than seven options:
	<ul>
		<li>Type a character: focus moves to the next item with a name that starts with the typed character.</li>
		<li>Type multiple characters in rapid succession: focus moves to the next item with a name that starts with the string of characters typed.</li>
	</ul>
	</li>
	<li><strong>Multiple Selection</strong>: Authors may implement either of two interaction models to support multiple selection: a recommended model that does not require the user to hold a modifier key, such as <kbd>Shift</kbd> or <kbd>Control</kbd>, while navigating the list or an alternative model that does require modifier keys to be held while navigating in order to avoid losing selection states.
	<ul>
		<li>Recommended selection model -- holding modifier keys is not necessary:
		<ul>
			<li><kbd>Space</kbd>: changes the selection state of the focused option .</li>
			<li><kbd>Shift + Down Arrow</kbd> (Optional): Moves focus to and toggles the selected state of the next option.</li>
			<li><kbd>Shift + Up Arrow</kbd> (Optional): Moves focus to and toggles the selected state of the previous option.</li>
			<li><kbd>Shift + Space</kbd> (Optional): Selects contiguous items from the most recently selected item to the focused item.</li>
			<li><kbd>Control + Shift + Home</kbd> (Optional): Selects the focused option and all options up to the first option. Optionally, moves focus to the first option.</li>
			<li><kbd>Control + Shift + End</kbd> (Optional): Selects the focused option and all options down to the last option. Optionally, moves focus to the last option.</li>
			<li><kbd>Control + A</kbd> (Optional): Selects all options in the list. Optionally, if all options are selected, it may also unselect all options.</li>
		</ul>
		</li>
	</ul>
	</li>
</ul>

<h3 id="Required_JavaScript_features">Required JavaScript features</h3>

<h4 id="selecting_an_option_in_a_single_select_listbox">selecting an option in a single select listbox</h4>

<p>When the user selects an option, the following must occur:</p>

<ol>
	<li>Deselect the previously selected option, setting the aria-selected to false, or removing the attribute altogether, changing the appearance of the newly unselected option to appear not selected.</li>
	<li>Select the newly selected option, setting aria-selected="true" on the option and changing the appearance of the newly selected option to appear selected.</li>
	<li>Update the <code>aria-activedescendant</code> value on the listbox to the id of the newly selected option</li>
	<li>Visually handle the blur, focus, and selected states of the option</li>
</ol>

<h4 id="Toggling_the_state_of_an_option_in_a_multi_select_listbox">Toggling the state of an option in a multi select listbox</h4>

<p>When the user clicks on an option, hits <kbd>Space</kbd> when focused on an option, or otherwise toggles the state of an option, the following must occur:</p>

<ol>
	<li>Toggle the aria-selected state of the currently focused option, changing the state of the aria-selected to true if it was false or false if it was true.</li>
	<li>Change the appearance of the option to reflect it's selected state</li>
	<li>Update the aria-activedescendant value on the listbox to the id of the option the user just interacted with, even if they toggled the option to be unselected.</li>
</ol>

<div class="note">
<p> <span class="ILfuVd yZ8quc">The first rule of ARIA use is you can use a native feature with the semantics and behavior you require already built in, instead of re-purposing an element and <strong>adding</strong> an ARIA role, state or property to make it accessible, then do so. The &lt;select&gt; element with descendant &lt;option&gt; elements handles all the needed interactions natively.</span></p>
</div>

<h2 id="Examples">Examples</h2>

<h4 class="p1" id="Example_1_A_single_select_listbox_that_uses_aria-activedescendant">Example 1: A single select listbox that uses aria-activedescendant</h4>

<p class="p2">The snippet below shows how the listbox role is added directly into the html source code. </p>

<pre class="brush: html">&lt;p id="listbox1label" role="label"&gt;Select a color:&lt;/p&gt;
&lt;div role="listbox" tabindex="0" id="listbox1" aria-labelledby="listbox1label"
  onclick="return listItemClick(event);"
  onkeydown="return listItemKeyEvent(event);"
  onkeypress="return listItemKeyEvent(event);"
  aria-activedescendant="listbox1-1"&gt;
    &lt;div role="option" id="listbox1-1" class="selected" aria-selected="true"&gt;Green&lt;/div&gt;
    &lt;div role="option" id="listbox1-2"&gt;Orange&lt;/div&gt;
    &lt;div role="option" id="listbox1-3"&gt;Red&lt;/div&gt;
    &lt;div role="option" id="listbox1-4"&gt;Blue&lt;/div&gt;
    &lt;div role="option" id="listbox1-5"&gt;Violet&lt;/div&gt;
    &lt;div role="option" id="listbox1-6"&gt;Periwinkle&lt;/div&gt;
&lt;/div&gt;
</pre>

<p>This could have more easily been handled with the native HTML <a href="en-US/docs/Web/HTML/Element/select"><code>&lt;select&gt;</code> </a>and<a href="en-US/docs/Web/HTML/Element/label"> <code>&lt;label&gt;</code></a> elements</p>

<pre class="brush: html">&lt;label for="listbox1"&gt;Select a color:&lt;/label&gt;
&lt;select id="listbox1"&gt;
   &lt;option selected&gt;Green&lt;/option&gt;
   &lt;option&gt;Orange&lt;/option&gt;
   &lt;option&gt;Red&lt;/option&gt;
   &lt;option&gt;Blue&lt;/option&gt;
   &lt;option&gt;Violet&lt;/option&gt;
   &lt;option&gt;Periwinkle&lt;/option&gt;
&lt;/select&gt;</pre>

<h4 id="More_examples">More examples</h4>

<ul>
	<li><a href="https://w3c.github.io/aria-practices/examples/listbox/listbox-scrollable.html">Scrollable Listbox Example</a>: Single-select listbox that scrolls to reveal more options, similar to HTML <code>select</code> with <code>size</code> attribute greater than one.</li>
	<li><a href="https://w3c.github.io/aria-practices/examples/listbox/listbox-collapsible.html">Collapsible Dropdown Listbox Example</a>: Single-select collapsible listbox that expands when activated, similar to HTML <code>select</code> with the attribute <code>size="1"</code>.</li>
	<li><a href="https://w3c.github.io/aria-practices/examples/listbox/listbox-rearrangeable.html">Example Listboxes with Rearrangeable Options</a>: Examples of both single-select and multi-select listboxes with accompanying toolbars where options can be added, moved, and removed.</li>
</ul>

<h2 id="Best_practices">Best practices</h2>

<ul class="ul1">
	<li class="li3">To be keyboard accessible, authors should <a class="external" href="https://www.w3.org/TR/wai-aria-1.1/#managingfocus">manage focus</a> of all descendants of this role.</li>
	<li class="li3">It is recommended that authors use different styling for the selection when the list is not focused, e.g. a non-active selection is often shown with a lighter background colour.</li>
	<li class="li3">If the listbox is not part of another widget, it should have the <code><span class="s1">aria-labelledby</span></code> property set.</li>
	<li class="li3">If one or more entries are not DOM children of listbox, additional <span class="s1">aria-*</span> properties will need to be set (see <a class="external" href="http://www.w3.org/TR/wai-aria-practices/#listbox_div">ARIA Best Practices</a>).</li>
	<li class="li3">If there is a valid reason to <a class="external" href="https://www.w3.org/TR/wai-aria-1.1/#aria-expanded">expand</a> the listbox, the <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Combobox_Role"><code>combobox</code></a> role may be more appropriate.</li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
		</tr>
		<tr>
			<td>{{SpecName("ARIA","#listbox","ARIA listbox role")}}</td>
			<td>{{Spec2('ARIA')}}</td>
		</tr>
		<tr>
			<td>{{SpecName("ARIA Authoring Practices","#Listbox","Listbox Role")}}</td>
			<td>{{Spec2('ARIA Authoring Practices')}}</td>
		</tr>
	</tbody>
</table>

<h2 id="Screen_reader_support">Screen reader support</h2>

<p>TBD</p>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/docs/Web/HTML/Element/select">HTML <code>&lt;select&gt;</code> element</a></li>
	<li><a href="/en-US/docs/Web/HTML/Element/label">HTML <code>&lt;label&gt;</code> element</a></li>
	<li><a href="/en-US/docs/Web/HTML/Element/option">HTML <code>&lt;option&gt;</code> element</a></li>
	<li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Combobox_Role">ARIA: <code>combobox</code> role</a></li>
	<li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Option_Role">ARIA: <code>option</code> role</a></li>
	<li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/list_Role">ARIA: <code>list</code> role</a></li>
	<li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Listitem_role">ARIA: <code>listitem</code> role</a></li>
	<li class="li2"><a href="https://www.w3.org/TR/wai-aria-practices/#Listbox">ARIA Best Practices – Listbox</a></li>
	<li class="li2"><a href="https://www.w3.org/TR/wai-aria-1.1/#listbox">ARIA Role Model – Listbox</a></li>
</ul>
